clang 10.0.0git

Functions
NestedNameSpecifier.cpp File Reference
`#include "clang/AST/NestedNameSpecifier.h"`
`#include "clang/AST/ASTContext.h"`
`#include "clang/AST/Decl.h"`
`#include "clang/AST/DeclCXX.h"`
`#include "clang/AST/DeclTemplate.h"`
`#include "clang/AST/PrettyPrinter.h"`
`#include "clang/AST/TemplateName.h"`
`#include "clang/AST/Type.h"`
`#include "clang/AST/TypeLoc.h"`
`#include "clang/Basic/LLVM.h"`
`#include "clang/Basic/LangOptions.h"`
`#include "clang/Basic/SourceLocation.h"`
`#include "llvm/ADT/FoldingSet.h"`
`#include "llvm/ADT/SmallVector.h"`
`#include "llvm/Support/Casting.h"`
`#include "llvm/Support/Compiler.h"`
`#include "llvm/Support/ErrorHandling.h"`
`#include "llvm/Support/raw_ostream.h"`
`#include <algorithm>`
`#include <cassert>`
`#include <cstdlib>`
`#include <cstring>`
Include dependency graph for NestedNameSpecifier.cpp:

Go to the source code of this file.

## Functions
static SourceLocation | LoadSourceLocation (void *Data, unsigned Offset)
| Load a (possibly unaligned) source location from a given address and offset. More...
static void * | LoadPointer (void *Data, unsigned Offset)
| Load a (possibly unaligned) pointer from a given address and offset. More...
static void | Append (char *Start, char *End, char *&Buffer, unsigned &BufferSize, unsigned &BufferCapacity)
static void | SaveSourceLocation (SourceLocation Loc, char *&Buffer, unsigned &BufferSize, unsigned &BufferCapacity)
| Save a source location to the given buffer. More...
static void | SavePointer (void *Ptr, char *&Buffer, unsigned &BufferSize, unsigned &BufferCapacity)
| Save a pointer to the given buffer. More...

## Function Documentation

## ◆ Append()

static void Append | ( | char * | Start,
|  | char * | End,
|  | char *& | Buffer,
|  | unsigned & | BufferSize,
|  | unsigned & | BufferCapacity
| ) |  |
| static

Definition at line 474 of file NestedNameSpecifier.cpp.

References max(), and memcpy().

Referenced by clang::NestedNameSpecifierLocBuilder::NestedNameSpecifierLocBuilder(), clang::NestedNameSpecifierLocBuilder::operator=(), SavePointer(), and SaveSourceLocation().

## ◆ LoadPointer()

static void* LoadPointer | ( | void * | Data,
|  | unsigned | Offset
| ) |  |
| static

Load a (possibly unaligned) pointer from a given address and offset.

Definition at line 415 of file NestedNameSpecifier.cpp.

References memcpy(), and clang::Result.

Referenced by clang::NestedNameSpecifierLoc::getLocalSourceRange(), and clang::NestedNameSpecifierLoc::getTypeLoc().

## ◆ LoadSourceLocation()

static SourceLocation LoadSourceLocation | ( | void * | Data,
|  | unsigned | Offset
| ) |  |
| static

Load a (possibly unaligned) source location from a given address and offset.

Definition at line 407 of file NestedNameSpecifier.cpp.

References clang::SourceLocation::getFromRawEncoding(), and memcpy().

Referenced by clang::NestedNameSpecifierLoc::getLocalSourceRange().

## ◆ SavePointer()

static void SavePointer | ( | void * | Ptr,
|  | char *& | Buffer,
|  | unsigned & | BufferSize,
|  | unsigned & | BufferCapacity
| ) |  |
| static

Save a pointer to the given buffer.

Definition at line 507 of file NestedNameSpecifier.cpp.

References Append(), and clang::NestedNameSpecifierLocBuilder::NestedNameSpecifierLocBuilder().

Referenced by clang::NestedNameSpecifierLocBuilder::Extend().

## ◆ SaveSourceLocation()

static void SaveSourceLocation | ( | SourceLocation | Loc,
|  | char *& | Buffer,
|  | unsigned & | BufferSize,
|  | unsigned & | BufferCapacity
| ) |  |
| static

Save a source location to the given buffer.

Definition at line 498 of file NestedNameSpecifier.cpp.

References Append(), and clang::SourceLocation::getRawEncoding().

Referenced by clang::NestedNameSpecifierLocBuilder::Extend(), clang::NestedNameSpecifierLocBuilder::MakeGlobal(), and clang::NestedNameSpecifierLocBuilder::MakeSuper().